using System;
using System.Collections;
using System.Drawing;
using PaintDotNet;
using PaintDotNet.Effects;

namespace AlphaSpace
{
	public class AlphaSpace : PaintDotNet.Effects.Effect
	{
		public static string StaticName {
			get { return "AlphaSpace"; }
		}

		public static Bitmap StaticIcon {
			get { System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AlphaSpace));
			 
				return (System.Drawing.Bitmap)resources.GetObject("EffectPluginIcon"); }
		}

		public static string StaticSubMenuName {
// Use for no submenu
// return "My SubMenu"; // Use for custom submenu
			get { return null; }
		}

		public AlphaSpace() : base(AlphaSpace.StaticName, AlphaSpace.StaticIcon, AlphaSpace.StaticSubMenuName, true)
		{

		}

		public override EffectConfigDialog CreateConfigDialog()
		{
			return new AlphaSpaceConfigDialog();
		}

		public unsafe override void Render(EffectConfigToken parameters, RenderArgs dstArgs, RenderArgs srcArgs, Rectangle[] rois, int startIndex, int length)
		{
			AlphaSpaceConfigToken token = (AlphaSpaceConfigToken)parameters;
            for (int r = startIndex; r < startIndex + length; ++r)
            {
                Rectangle rect = rois[r];

                for (int y = rect.Top; y < rect.Bottom; ++y)
                {
                    ColorBgra *srcRowPtr = srcArgs.Surface.GetPointAddress(rect.Left, y);
                    ColorBgra *dstRowPtr = dstArgs.Surface.GetPointAddress(rect.Left, y);
                    ColorBgra *dstRowEndPtr = dstRowPtr + rect.Width;

                    
                        while (dstRowPtr < dstRowEndPtr)
                        {
                            ColorBgra col = *srcRowPtr;
                            int i = col.GetIntensityByte();
                            int shiftIndex = i * 256;
                            if(token.UseBlack==false)
                            {
                            int PointR = 255-col.R;
							int PointG = 255-col.G;
							int PointB = 255-col.B;
							int ProzR = (int)(((double)PointR / (double)token.Tolerance)*100);
							int ProzG = (int)(((double)PointG / (double)token.Tolerance)*100);
							int ProzB = (int)(((double)PointB / (double)token.Tolerance)*100);
							byte NewA = col.A;
							if (ProzR < 100)
							{
								NewA = (byte)(2.55 * ProzR);
							}
							if (ProzG < 100)
							{
								NewA = (byte)((NewA + (2.55 * ProzR)) / 2);
							}
							if (ProzB < 100)
							{
								NewA = (byte)(((NewA * 2) + (2.55 * ProzR)) / 3);
							}


                            col.A = NewA;
                            }
                            else
                            {
                            int PointR = col.R;
							int PointG = col.G;
							int PointB = col.B;
							int ProzR = (int)(((double)PointR / (double)token.Tolerance)*100);
							int ProzG = (int)(((double)PointG / (double)token.Tolerance)*100);
							int ProzB = (int)(((double)PointB / (double)token.Tolerance)*100);
							byte NewA = col.A;
							if (ProzR < 100)
							{
								NewA = (byte)(2.55 * ProzR);
							}
							if (ProzG < 100)
							{
								NewA = (byte)((NewA + (2.55 * ProzR)) / 2);
							}
							if (ProzB < 100)
							{
								NewA = (byte)(((NewA * 2) + (2.55 * ProzR)) / 3);
							}
							
							col.A = NewA;
                            }
                            *dstRowPtr = col;
                            ++dstRowPtr;
                            ++srcRowPtr;
                        }
                    
                }
            }
            

		}
	}

}
