using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using PaintDotNet.Effects;
using PaintDotNet;

namespace AlphaSpace
{
	public class AlphaSpaceConfigDialog : PaintDotNet.Effects.EffectConfigDialog
	{
		private Button buttonOK;
		internal System.Windows.Forms.TrackBar TrackBar1;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.RadioButton RadioButton1;
		internal System.Windows.Forms.RadioButton RadioButton2;
		internal System.Windows.Forms.Panel Panel1;
		internal System.Windows.Forms.Panel Panel2;
		internal System.Windows.Forms.Panel Panel3;
		internal System.Windows.Forms.Panel Panel4;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Panel Panel5;
		internal System.Windows.Forms.Panel Panel6;
		internal System.Windows.Forms.NumericUpDown NumericUpDown1;
		internal System.Windows.Forms.Button Button1;
		private Button buttonCancel;

		public AlphaSpaceConfigDialog()
		{
			InitializeComponent();
		}

		protected override void InitialInitToken()
		{
			theEffectToken = new AlphaSpaceConfigToken();
		}

		protected override void InitTokenFromDialog()
		{
			// ((AlphaSpaceConfigToken)EffectToken).variable = dialogVariable;
			((AlphaSpaceConfigToken)EffectToken).Tolerance = TrackBar1.Value;
			((AlphaSpaceConfigToken)EffectToken).UseBlack = RadioButton1.Checked;

		}

		protected override void InitDialogFromToken(EffectConfigToken effectToken)
		{
			// AlphaSpaceConfigToken token = (AlphaSpaceConfigToken)effectToken;
			AlphaSpaceConfigToken token = (AlphaSpaceConfigToken)effectToken;
			TrackBar1.Value = token.Tolerance;
			NumericUpDown1.Value = token.Tolerance;
			RadioButton1.Checked = token.UseBlack;
			// dialogVariable = token.variable;
		}

		private void InitializeComponent()
		{
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AlphaSpaceConfigDialog));
			this.buttonCancel = new System.Windows.Forms.Button();
			this.buttonOK = new System.Windows.Forms.Button();
			this.TrackBar1 = new System.Windows.Forms.TrackBar();
			this.Label1 = new System.Windows.Forms.Label();
			this.RadioButton1 = new System.Windows.Forms.RadioButton();
			this.RadioButton2 = new System.Windows.Forms.RadioButton();
			this.Panel1 = new System.Windows.Forms.Panel();
			this.Panel2 = new System.Windows.Forms.Panel();
			this.Panel3 = new System.Windows.Forms.Panel();
			this.Panel4 = new System.Windows.Forms.Panel();
			this.Label2 = new System.Windows.Forms.Label();
			this.Panel5 = new System.Windows.Forms.Panel();
			this.Panel6 = new System.Windows.Forms.Panel();
			this.NumericUpDown1 = new System.Windows.Forms.NumericUpDown();
			this.Button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)this.TrackBar1).BeginInit();
			((System.ComponentModel.ISupportInitialize)this.NumericUpDown1).BeginInit();
			this.SuspendLayout();
			//
			//buttonCancel
			//
			this.buttonCancel.Anchor = (System.Windows.Forms.AnchorStyles)(System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.buttonCancel.Location = new System.Drawing.Point(285, 92);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.Size = new System.Drawing.Size(75, 23);
			this.buttonCancel.TabIndex = 1;
			this.buttonCancel.Text = "Cancel";
			this.buttonCancel.UseVisualStyleBackColor = true;
			this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
			
			//
			//buttonOK
			//
			this.buttonOK.Anchor = (System.Windows.Forms.AnchorStyles)(System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.buttonOK.Location = new System.Drawing.Point(204, 92);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.Size = new System.Drawing.Size(75, 23);
			this.buttonOK.TabIndex = 2;
			this.buttonOK.Text = "OK";
			this.buttonOK.UseVisualStyleBackColor = true;
			this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
			
			//
			//TrackBar1
			//
			this.TrackBar1.Location = new System.Drawing.Point(12, 56);
			this.TrackBar1.Maximum = 255;
			this.TrackBar1.Name = "TrackBar1";
			this.TrackBar1.Size = new System.Drawing.Size(246, 42);
			this.TrackBar1.TabIndex = 3;
			this.TrackBar1.TickFrequency = 0;
			this.TrackBar1.TickStyle = System.Windows.Forms.TickStyle.None;
			this.TrackBar1.Value = 125;
			this.TrackBar1.Scroll += new System.EventHandler(this.TrackBar1_Scroll);
			//
			//Label1
			//
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(12, 9);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(99, 13);
			this.Label1.TabIndex = 4;
			this.Label1.Text = "Transparency Color";
			//
			//RadioButton1
			//
			this.RadioButton1.AutoSize = true;
			this.RadioButton1.Location = new System.Drawing.Point(308, 23);
			this.RadioButton1.Name = "RadioButton1";
			this.RadioButton1.Size = new System.Drawing.Size(52, 17);
			this.RadioButton1.TabIndex = 5;
			this.RadioButton1.Text = "Black";
			this.RadioButton1.UseVisualStyleBackColor = true;
			this.RadioButton1.CheckedChanged += new System.EventHandler(this.NumericUpDown1_ValueChanged);
            
			//
			//RadioButton2
			//
			this.RadioButton2.AutoSize = true;
			this.RadioButton2.Checked = true;
			this.RadioButton2.Location = new System.Drawing.Point(249, 23);
			this.RadioButton2.Name = "RadioButton2";
			this.RadioButton2.Size = new System.Drawing.Size(53, 17);
			this.RadioButton2.TabIndex = 6;
			this.RadioButton2.TabStop = true;
			this.RadioButton2.Text = "White";
			this.RadioButton2.UseVisualStyleBackColor = true;
			this.RadioButton2.CheckedChanged += new System.EventHandler(this.NumericUpDown1_ValueChanged);
            
			//
			//Panel1
			//
			this.Panel1.BackColor = System.Drawing.SystemColors.ButtonShadow;
			this.Panel1.Location = new System.Drawing.Point(120, 15);
			this.Panel1.Name = "Panel1";
			this.Panel1.Size = new System.Drawing.Size(246, 1);
			this.Panel1.TabIndex = 7;
			//
			//Panel2
			//
			this.Panel2.BackColor = System.Drawing.SystemColors.ButtonHighlight;
			this.Panel2.Location = new System.Drawing.Point(120, 16);
			this.Panel2.Name = "Panel2";
			this.Panel2.Size = new System.Drawing.Size(246, 1);
			this.Panel2.TabIndex = 9;
			//
			//Panel3
			//
			this.Panel3.BackColor = System.Drawing.SystemColors.ButtonHighlight;
			this.Panel3.Location = new System.Drawing.Point(75, 48);
			this.Panel3.Name = "Panel3";
			this.Panel3.Size = new System.Drawing.Size(291, 1);
			this.Panel3.TabIndex = 12;
			//
			//Panel4
			//
			this.Panel4.BackColor = System.Drawing.SystemColors.ButtonShadow;
			this.Panel4.Location = new System.Drawing.Point(75, 47);
			this.Panel4.Name = "Panel4";
			this.Panel4.Size = new System.Drawing.Size(291, 1);
			this.Panel4.TabIndex = 11;
			//
			//Label2
			//
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(14, 40);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(55, 13);
			this.Label2.TabIndex = 10;
			this.Label2.Text = "Tolerance";
			//
			//Panel5
			//
			this.Panel5.BackColor = System.Drawing.SystemColors.ButtonHighlight;
			this.Panel5.Location = new System.Drawing.Point(15, 83);
			this.Panel5.Name = "Panel5";
			this.Panel5.Size = new System.Drawing.Size(351, 1);
			this.Panel5.TabIndex = 14;
			//
			//Panel6
			//
			this.Panel6.BackColor = System.Drawing.SystemColors.ButtonShadow;
			this.Panel6.Location = new System.Drawing.Point(15, 82);
			this.Panel6.Name = "Panel6";
			this.Panel6.Size = new System.Drawing.Size(351, 1);
			this.Panel6.TabIndex = 13;
			//
			//NumericUpDown1
			//
			this.NumericUpDown1.Location = new System.Drawing.Point(264, 56);
			this.NumericUpDown1.Maximum = new decimal(new int[] {255, 0, 0, 0});
			this.NumericUpDown1.Name = "NumericUpDown1";
			this.NumericUpDown1.Size = new System.Drawing.Size(70, 20);
			this.NumericUpDown1.TabIndex = 15;
			this.NumericUpDown1.Value = new decimal(new int[] {125, 0, 0, 0});
			this.NumericUpDown1.ValueChanged += new System.EventHandler(this.NumericUpDown1_ValueChanged);
            
			//
			//Button1
			//
			this.Button1.Image = (System.Drawing.Image)resources.GetObject("Button1.Image");
			this.Button1.ImageAlign = System.Drawing.ContentAlignment.BottomRight;
			this.Button1.Location = new System.Drawing.Point(340, 56);
			this.Button1.Name = "Button1";
			this.Button1.Size = new System.Drawing.Size(20, 20);
			this.Button1.TabIndex = 16;
			this.Button1.UseVisualStyleBackColor = true;
			this.Button1.Click += new System.EventHandler(this.Reset);
			
			//
			//AlphaSpaceConfigDialog
			//
			this.AutoScaleDimensions = new System.Drawing.SizeF(96f, 96f);
			this.ClientSize = new System.Drawing.Size(372, 127);
			this.Controls.Add(this.buttonOK);
			this.Controls.Add(this.Button1);
			this.Controls.Add(this.NumericUpDown1);
			this.Controls.Add(this.Panel5);
			this.Controls.Add(this.Panel6);
			this.Controls.Add(this.Panel3);
			this.Controls.Add(this.Panel4);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.Panel2);
			this.Controls.Add(this.Panel1);
			this.Controls.Add(this.RadioButton2);
			this.Controls.Add(this.RadioButton1);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.TrackBar1);
			this.Controls.Add(this.buttonCancel);
			this.Name = "AlphaSpaceConfigDialog";
			this.ShowIcon = false;
			this.Text = "AlphaSpace";
			this.Controls.SetChildIndex(this.buttonCancel, 0);
			this.Controls.SetChildIndex(this.TrackBar1, 0);
			this.Controls.SetChildIndex(this.Label1, 0);
			this.Controls.SetChildIndex(this.RadioButton1, 0);
			this.Controls.SetChildIndex(this.RadioButton2, 0);
			this.Controls.SetChildIndex(this.Panel1, 0);
			this.Controls.SetChildIndex(this.Panel2, 0);
			this.Controls.SetChildIndex(this.Label2, 0);
			this.Controls.SetChildIndex(this.Panel4, 0);
			this.Controls.SetChildIndex(this.Panel3, 0);
			this.Controls.SetChildIndex(this.Panel6, 0);
			this.Controls.SetChildIndex(this.Panel5, 0);
			this.Controls.SetChildIndex(this.NumericUpDown1, 0);
			this.Controls.SetChildIndex(this.Button1, 0);
			this.Controls.SetChildIndex(this.buttonOK, 0);
			((System.ComponentModel.ISupportInitialize)this.TrackBar1).EndInit();
			((System.ComponentModel.ISupportInitialize)this.NumericUpDown1).EndInit();
			this.ResumeLayout(false);
			this.PerformLayout();

		}

		private void buttonOK_Click(object sender, EventArgs e)
		{
			FinishTokenUpdate();
			DialogResult = DialogResult.OK;
			this.Close();
		}

		private void buttonCancel_Click(object sender, EventArgs e) 
		{
			DialogResult = DialogResult.Cancel;
			this.Close();
		}

		private void TrackBar1_Scroll(object sender, System.EventArgs e) 
		{
			NumericUpDown1.Value = TrackBar1.Value;
			InitTokenFromDialog();
			FinishTokenUpdate();

		}

		private void AlphaSpaceConfigDialog_Load(object sender, System.EventArgs e) 
		{

		}

		private void NumericUpDown1_ValueChanged(object sender, System.EventArgs e) 
		{
			TrackBar1.Value = (int)NumericUpDown1.Value;
			InitTokenFromDialog();
			FinishTokenUpdate();
		}
		private void Reset(object sender, EventArgs e)
		{
			TrackBar1.Value = 125;
			NumericUpDown1.Value= 125;

		}
	}
}
